module Parse
where

class Parse a where
    parse :: String -> (a, String)

instance Parse () where
    parse = (,) ()

instance (Read car, Parse cdr) => Parse (car, cdr) where
    parse str = case reads str of { (car,str'):_ ->
		case parse str' of (cdr,str'') -> ((car, cdr), str'') }
